#include <stdio.h>

//declarao das estruturas de dados
typedef struct filho {
	char nome[20], data_nascimento[10];
	struct filho **amigos;
	struct filho *prox;
} Filho;

typedef struct pai {
		    char nome[20], nome_conjuge[20];
		    int nro_filhos;
		    struct pai *prox;
		    Filho *filhos;
} Pai;

typedef struct {
        Pai *ini, *fim;
} Listagem;        

//main hipottico, para testar o uso das estruturas
int main(void) {
    
    Filho *p1, *p2, *p3;

    //criando alguns ns da lista de filhos de um pai qualquer

    p1=(Filho*) malloc(sizeof(Filho));
    if (p1==NULL)
       printf("Erro - p1 no alocado\n");
    else {
         strcpy(p1->nome,"thiago");
         strcpy(p1->data_nascimento,"28-04-78");
         p1->prox=NULL;
    }
    
    p2=(Filho*) malloc(sizeof(Filho));
    if (p2==NULL)
       printf("Erro - p2 no alocado\n");
    else {
         strcpy(p2->nome,"ariani");
         strcpy(p2->data_nascimento,"07-07-77");
         p2->prox=NULL;
    }
    p1->prox=p2;
    
    p3=(Filho*) malloc(sizeof(Filho));
    if (p3==NULL)
       printf("Erro - p3 no alocado\n");
    else {
         strcpy(p3->nome,"anselmo");
         strcpy(p3->data_nascimento,"14-06-55");
         p3->prox=NULL;
    }
    p2->prox=p3;
    
    //criando uma lista de amigos para um filho qualquer
    
    p1->amigos=(Filho**) malloc(3*sizeof(Filho*));
    p1->amigos[0]=p2;
    p1->amigos[1]=p3;
    p1->amigos[2]=NULL;
    
    printf("Os amigos de %s sao: %s e %s\n\n",p1->nome,p1->amigos[0]->nome,p1->amigos[1]->nome);
    
    free(p1->amigos);
    free(p1);
    free(p2);
    free(p3);
        
    system("pause");
    return(0);
}
